package com.zipcodewilmington;


import java.util.*;


/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {

        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {

        return array[array.length - 1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {

        return array[array.length - 2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {


        if (Arrays.asList(array).contains(value)) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {

        String[] newArr = new String[array.length];
        int counter = 0;
        for (int i = array.length - 1; i >= 0; i--) {
            newArr[counter] = array[i];

            counter++;
            //counter = counter +1;
        }
        return newArr;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {

        boolean isPal = false;
        for (int i = 0; i < array.length; i++) {
            if (reverse(array)[0].equals(array[i])) {
                isPal = true;

            } else {

            }
        }
        return isPal;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        String character = "abcdefghijklmnopqrstuvwxyz";
        String stringArray = "";

        for (int i = 0; i < array.length; i++) {
            stringArray = stringArray + array[i];
        }
        stringArray = stringArray.toLowerCase();

        for (int i = 0; i < stringArray.length(); i++) {
            for (int j = 0; j < character.length(); j++) {
                if (stringArray.indexOf(character.charAt(j)) == -1) {
                    return false;

                }
            }
        }
        return true;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {

        int counter = 0;
        for (int i = 0; i < array.length; i++) {
            if (value.equals(array[i]))
                counter++;
        }
        return counter;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {

        StringBuilder newString = new StringBuilder();
        for (int i = 0; i < array.length; i++) {
            if (!array[i].equals(valueToRemove)) {
                newString.append(array[i] + " ");
            }

        }
        return newString.toString().split(" ");
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {

      String[] differentArray = new String[array.length];
      int counter = 0;
      for (int i = 1; i < array.length; i++){
          String newWord = array[i-1];
          if(!newWord.equals(array[i])){
              differentArray[counter] = array[i-1];
              counter++;
          }
      }
      differentArray[counter] = array[array.length -1];
      return Arrays.copyOf(differentArray, counter+1);
    }



    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {

        String [] newArray = new String[ array.length];
        int newIndex = 0;
        String last = array[0];
        String combiner = array[0];

        for (int i = 1; i < array.length; i++){
            if (!last.equals(array[i])){
                last = array[i];
                newArray[newIndex] = combiner;
                combiner = array[i];
                newIndex++;

            } else{
                combiner+= array[i];
            }
        }
        newArray[newIndex] = combiner;
        return Arrays.copyOf(newArray, newIndex +1);
    }
}

